/* move_type.h (Combinatorial Pyramids project)
 *  Copyright (C) 2003 Luc Brun
 *  email: luc.brun@univ-reims.fr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the version 2 of the GNU General Public
 *  License as published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#ifndef MOVE_TYPE_H
#define MOVE_TYPE_H
#include "type_obj.h"

typedef enum{right,up,left,down} move_type;

#define NB_MOVE 4


#ifdef __USE_MOVE_TYPE__
                                /* R   UP    L     D */
static move_type _reverse[4]   = {left,down,right,up};

#define REVERSE_SENSE(m_)   ( _reverse[m_])

#endif


extern int move_type_compute_step_clock(move_type,move_type);

#endif /* MOVE_TYPE_H*/


