/* pyramid_user_functions.h (Combinatorial Pyramids project)
 *  Copyright (C) 2003 Luc Brun
 *  email: luc.brun@univ-reims.fr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the version 2 of the GNU General Public
 *  License as published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#ifndef __PYRAMID_USER_FUNCTIONS_H__
#define __PYRAMID_USER_FUNCTIONS_H__

#include "point.h"



typedef any_ptr (*PFinit_node_value)(any_ptr,pyramid,vertex);
typedef float   (*PFinit_edge_value)(any_ptr,pyramid,vertex);
typedef void    (*PFfree)(any_ptr);
typedef bouleen (*PFequivalent)(pyramid,int,vertex,vertex,dart);
typedef double  (*PFvalue)(pyramid,vertex);
typedef double  (*PFparent_child)(pyramid,int,vertex,vertex,dart);
typedef any_ptr (*PFmerge)(any_ptr,pyramid,int,vertex,vertex);

typedef bouleen (*PFnew_segment)(pyramid,dart);
typedef void (*PFdraw_point)(pyramid,dart,point);

typedef void (*PFmerge_edge_value)(any_ptr,pyramid,int,dart,dart);

#define NULL_PFVALUE ((PFvalue)NULL)
#define NULL_PFEQUIVALENT ((PFequivalent)NULL)
#define NULL_PFPARENT_CHILD ((PFparent_child)NULL)
#define NULL_PFNEW_SEGMENT ((PFnew_segment)NULL)
#define NULL_PFMERGE_DART ((PFmerge_edge_value)NULL)
#define NULL_PFMERGE ((PFmerge)NULL)

typedef struct
{
  any_ptr data;
  PFinit_node_value init;
  PFmerge merge;
} vertex_data;
typedef struct
{
  any_ptr data;
  PFinit_edge_value init;
  PFmerge_edge_value merge;
}dart_data;

typedef struct
{
  PFequivalent equiv;
  PFvalue value;
  PFparent_child interest;
  PFmerge merge;/* if null -> the one of vertex data is used */
  PFmerge_edge_value merge_dart; /* if null -> the one of vertex data is used */
} parallel_seg;

typedef struct
{
  PFequivalent equiv;
  PFmerge merge;		/* if null -> the one of vertex data is used */
  PFmerge_edge_value merge_dart; /* if null -> the one of vertex data is used */
} sequential_seg;

#endif
