/* pyramid_draw_ppm.c (Combinatorial Pyramids project)
 *  Copyright (C) 2003 Luc Brun
 *  email: luc.brun@univ-reims.fr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the version 2 of the GNU General Public
 *  License as published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#include "pyramid_draw_pgm.h"
#include "image.h"

#define ABS(a) ((a)<0?(-(a)):(a))

static   image img=NULL_IMAGE;
static int yellow1[3]={255,255,0};
static int yellow2[3]={128,128,0};

static int* color1;
static int* color2;
static int * col;
extern void pyramid_draw_ppm_init(int dimx,int dimy,
				  int* col1,
				  int * col2)
{
  if(img != NULL_IMAGE)
    DEFAIRE_image(img);

  img=FAIRE_image();
  
  image_initialize(img,
		   3,
		   dimx,
		   dimy);  
  if(col1==NULL)
    color1=yellow1;
  else
    color1=col1;
  if(col2==NULL)
    color2=yellow2;
  else
    color2=col2;
  col=color1;
}
extern void pyramid_draw_ppm_draw_point(pyramid P,dart b,point p)
{
  assert(img&&image_move_to(img,p));
  image_move_to(img,p);
  image_ecrire_pixel(img,col);
}
extern bouleen pyramid_draw_ppm_new_seg(pyramid P,dart b)
{
  dart phi_b,sig_b;
  dart phi2_b,phi_seg_b;
  dart b_sign;
  
  sig_b=pyramid_give_sigma(P,b);
  phi_b=pyramid_give_sigma(P,-b);
  phi2_b=pyramid_give_sigma(P,phi_b);
  phi_seg_b=pyramid_give_sigma(P,-sig_b);
  
  if(phi2_b==b)
    {
      if(ABS(b) < ABS(phi_b))
	b_sign=-phi_b;
      else
	b_sign=b;
    }
  if(phi_seg_b == -b)
    {
      if(ABS(b)<ABS(sig_b))
	b_sign=sig_b;
      else
	b_sign=b;
    }

  if(b_sign>0)
    col=color1;
  else
    col=color2;

  return vrai;
}
extern image pyramid_draw_ppm_give_image()
{
  return img;
}
