/* tab_dart.c (Combinatorial Pyramids project)
 *  Copyright (C) 2003 Luc Brun
 *  email: luc.brun@univ-reims.fr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the version 2 of the GNU General Public
 *  License as published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <assert.h>
#include "objet.h"
#include "tab_dart.h"
#include "tab_int.h"


#define Negative_dart   SELF(negative_dart)
#define Positive_dart   SELF(positive_dart)


struct tab_dart
{
  tab_int negative_dart;
  tab_int positive_dart;
};

tab_dart FAIRE_tab_dart()
{
  INSTANCIER(tab_dart);
  
  Negative_dart=FAIRE_tab_int();
  Positive_dart=FAIRE_tab_int();

  return self;
}

/*---------------------------------------------------------------------------*/

void DEFAIRE_tab_dart(tab_dart self)
{  
  DEFAIRE_tab_int(Negative_dart);
  DEFAIRE_tab_int(Positive_dart);

  free(self);
}
/*---------------------------------------------------------------------------*/
dart  tab_dart_give_value(tab_dart self,dart d)
{

  assert(self);

  if(d<0)
    return tab_int_give_value(Negative_dart,-d);

  return   tab_int_give_value(Positive_dart,d);
}

void tab_dart_put_value(tab_dart self,dart d,dart value)
{
  assert(self);

  if(d<0)
    {
      tab_int_put_value(Negative_dart,-d,value);
      return;
    }
  tab_int_put_value(Positive_dart,d,value);

}
