/* tab_dart_value.c (Combinatorial Pyramids project)
 *  Copyright (C) 2003 Luc Brun
 *  email: luc.brun@univ-reims.fr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the version 2 of the GNU General Public
 *  License as published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <assert.h>
#include "objet.h"
#include "tab_dart_value.h"
#include "tab_float.h"


#define Negative_dart_value   SELF(negative_dart_value)
#define Positive_dart_value   SELF(positive_dart_value)


struct tab_dart_value
{
  tab_float negative_dart_value;
  tab_float positive_dart_value;
};

tab_dart_value FAIRE_tab_dart_value()
{
  INSTANCIER(tab_dart_value);
  
  Negative_dart_value=FAIRE_tab_float();
  Positive_dart_value=FAIRE_tab_float();

  return self;
}

/*---------------------------------------------------------------------------*/

void DEFAIRE_tab_dart_value(tab_dart_value self)
{  
  DEFAIRE_tab_float(Negative_dart_value);
  DEFAIRE_tab_float(Positive_dart_value);

  free(self);
}
/*---------------------------------------------------------------------------*/
dart_value  tab_dart_value_give_value(tab_dart_value self,int ind)
{

  assert(self);

  if(ind<0)
    return tab_float_give_value(Negative_dart_value,-ind);

  return   tab_float_give_value(Positive_dart_value,ind);
}

void tab_dart_value_put_value(tab_dart_value self,int ind,float value)
{
  assert(self);

  if(ind<0)
    {
      tab_float_put_value(Negative_dart_value,-ind,value);
      return;
    }
  tab_float_put_value(Positive_dart_value,ind,value);

}
