/* matrice.h (Combinatorial Pyramids project)
 *  Copyright (C) 2003 Luc Brun
 *  email: luc.brun@univ-reims.fr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the version 2 of the GNU General Public
 *  License as published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#ifndef  __MATRICE__
#define __MATRICE__

/* definition des types matrices */

#define DIM 3

typedef double vecteur[DIM];
typedef double matrice[DIM][DIM];
typedef double mat_covariance[DIM][DIM];
typedef double mat_passage[DIM][DIM];

extern void matrice_affiche_vect(vecteur);
extern void matrice_affiche_matrice(matrice);
extern void matrice_affecte_vect(vecteur,vecteur);
extern double matrice_scalaire_vect(vecteur,vecteur);
extern void matrice_vecteur_propre_principal(mat_covariance,vecteur,vecteur);
extern void matrice_val_vect_propre(mat_covariance,vecteur,mat_passage,matrice);
#endif

