/* para_nettoyage.c (Combinatorial Pyramids project)
 *  Copyright (C) 2003 Luc Brun
 *  email: luc.brun@univ-reims.fr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the version 2 of the GNU General Public
 *  License as published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#include "para_nettoyage.h"

static pyramid_value value_vertex=NULL;
static border_value value_edge=NULL;
static double seuil_size=50;

#define MIN(a,b) ((a)<(b)?(a):(b))
#define MAX(a,b) ((a)<(b)?(b):(a))

extern void init_para_nettoyage(pyramid_value p_value, border_value b_value)
{
  value_vertex=p_value;
  value_edge=b_value;
}
extern void para_nettoyage_put_seuil_size(double val)
{
  seuil_size=val;
}
bouleen para_nettoyage_lambda(pyramid P,
			      int level,
			      vertex V1,
			      vertex V2,
			      dart d)
{
  int size1, size2;

  size1 = pyramid_value_give_cardinal(value_vertex, V1);
  size2 = pyramid_value_give_cardinal(value_vertex, V2);
  size1=MIN(size1,size2);

  return (size1<seuil_size);
}
double para_nettoyage_value(pyramid P,
			    vertex mu)
{
  return (1/pyramid_value_give_cardinal(value_vertex, mu));
}
