/* quantification.c (Combinatorial Pyramids project)
 *  Copyright (C) 2003 Luc Brun
 *  email: luc.brun@univ-reims.fr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the version 2 of the GNU General Public
 *  License as published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#include "quantification.h"


void quantification(image img, image result, quantize quant)
{
	int*pix;
	int val;

	image_initialize(result,
	                 1,
	                 image_give_largeur(img),
									 image_give_hauteur(img));
	image_debut(img);
	image_debut(result);
	do
	{
		pix=image_lire_pixel(img);
		val=(int)quantize_give_color_index(quant,pix);
		image_ecrire_pixel(result,&val);
		image_pixel_suivant(result);
	}
	while(image_pixel_suivant(img));	
}
